unit Fmain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, AsfLocalizeServer,
  StdCtrls, ASFLocalizeClient, Buttons, DB, DBTables, ExtCtrls, DBCtrls,
  Grids, DBGrids;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    Files1: TMenuItem;
    Exit1: TMenuItem;
    Language1: TMenuItem;
    Button4: TButton;
    Button5: TButton;
    ComboBox1: TComboBox;
    LocServer: TAsfLocalizeServer;
    LocClient: TAsfLocalizeClient;
    Help1: TMenuItem;
    About1: TMenuItem;
    Button9: TButton;
    Label3: TLabel;
    Table1: TTable;
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses FSplash, grouping, FFolders;

{$R *.dfm}

procedure TMainForm.FormShow(Sender: TObject);
begin
  Edit1.Text := LocServer.DicPath;
  LocServer.CreateLanguageMenu(Language1, false, true);
  LocClient.SetGetAllProperties;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  MessageDlg(LocClient.Msg('This message is a test. Today is "%1" hour is "%2".', [DateToStr(Date), TimeToStr(Time)]), mtInformation, [mbOk], 0);
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
  frmGrouping.QuickRep1.Preview;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  Splash := TSplash.Create(Application);
  try
    Splash.ShowModal;
  finally
    Splash.Free;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  Table1.Active := not(Table1.Active);
  LocClient.SetGetAllProperties;
end;

procedure TMainForm.Button9Click(Sender: TObject);
begin
  try
    Folders := TFolders.Create(Application);
    if Folders.ShowModal = mrOk then
      begin
        Edit1.Text := Folders.PathList.Path;
        LocServer.DicPath := Edit1.Text;
      end;
  finally
    Folders.Free;
  end;
  LocServer.RegisterLanguages;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var
  IniMsg: String;
begin
  LocServer.Language := 'Default';
  IniMsg := LocClient.Msg('Actual Language is "%1".', [LocServer.Language]);
  if IniMsg = '' then
    IniMsg := 'Actual Language is ' + LocServer.Language;
  MessageDlg(IniMsg, mtInformation, [mbOk], 0);
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
  IniMsg: String;
begin
//  LocClient.SetGetAllProperties;
  LocServer.CreateLanguageMenu(Language1, false, true);
  IniMsg := LocClient.Msg('OK, now try test the program.', []);
  if IniMsg = '' then
    IniMsg := 'OK, now try test the program.';
  MessageDlg(IniMsg, mtInformation, [mbOk], 0);
end;

end.
