unit FMainEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ASFLocalizeServer, Buttons, ComCtrls, ToolWin,
  ExtDlgs, ExtCtrls, ImgList, ShellCtrls, AppEvnts;

type
  TFMain = class(TForm)
    ListBox1: TListBox;
    ComboBox1: TComboBox;
    Menu: TMainMenu;
    Files1: TMenuItem;
    EditLanguages: TMenuItem;
    New1: TMenuItem;
    Files2: TMenuItem;
    Exit1: TMenuItem;
    Label1: TLabel;
    ListBox2: TListBox;
    Edit1: TEdit;
    DeleteAllLanguages1: TMenuItem;
    RefreshLanguages1: TMenuItem;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    Post: TToolButton;
    Label4: TLabel;
    OpenPicture: TOpenPictureDialog;
    ImageList1: TImageList;
    Enable: TImageList;
    Disable: TImageList;
    Hot: TImageList;
    Delete: TToolButton;
    Label5: TLabel;
    Label6: TLabel;
    ToolButton1: TToolButton;
    Label3: TLabel;
    DeleteLanguage1: TMenuItem;
    New: TToolButton;
    Refresh: TToolButton;
    Edit2: TEdit;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    Sections1: TMenuItem;
    NewSection1: TMenuItem;
    NewSubSection1: TMenuItem;
    DeleteItem1: TMenuItem;
    DeleteSection1: TMenuItem;
    Panel1: TPanel;
    Image1: TImage;
    LocServer: TAsfLocalizeServer;
    procedure New1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure DeleteAllLanguages1Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure PostClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure RefreshClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure NewSection1Click(Sender: TObject);
    procedure NewSubSection1Click(Sender: TObject);
    procedure DeleteSection1Click(Sender: TObject);
    procedure DeleteItem1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure LocServerLanguageChange(Sender: TObject);
  private
    { Private declarations }
    procedure RefreshLanguageMenu;
    procedure ClearControls;
    procedure ChargeLanguage(Language: String);
  public
    { Public declarations }
  end;

var
  FMain: TFMain;

implementation

uses FNewLangNameDialog, StrUtils, IniFiles, FFolders, FNewKey;

{$R *.dfm}

{ TForm1 }

procedure TFMain.New1Click(Sender: TObject);
begin
  try
    NewLangNameDialog := TNewLangNameDialog.Create(Application);
    if NewLangNameDialog.ShowModal = mrOk then
      begin
        LocServer.SetNewLanguage(NewLangNameDialog.LangName.Text, NewLangNameDialog.Image1.Picture.Bitmap);
        RefreshLanguageMenu;
        LocServer.Language := NewLangNameDialog.LangName.Text;
      end;
  finally
    NewLangNameDialog.Free;
  end;
end;

procedure TFMain.FormShow(Sender: TObject);
begin
  Edit2.Text := LocServer.DicPath; //get path to languages.
  RefreshClick(nil);
  LocServerLanguageChange(nil);
end;

procedure TFMain.RefreshLanguageMenu;
begin
  LocServer.CreateLanguageMenu(EditLanguages, true, true);
  Post.Enabled := False;
  ComboBox1.Clear;
  ListBox1.Clear;
  ListBox2.Clear;
  Edit1.Clear;
end;

procedure TFMain.ComboBox1Change(Sender: TObject);
begin
  if LocServer.GetItems(ComboBox1.Text, ListBox1.Items) then
    begin
      ListBox1.ItemIndex := 0;
      if ListBox1.Count > 0 then ListBox1Click(nil);
      if ComboBox1.Text > '' then
        begin
          NewSection1.Enabled := True;
          NewSubSection1.Enabled := True;
          DeleteSection1.Enabled := True;
          DeleteItem1.Enabled := True;
        end
      else
        begin
          NewSection1.Enabled := False;
          NewSubSection1.Enabled := False;
          DeleteSection1.Enabled := False;
          DeleteItem1.Enabled := False;
        end;
    end;
end;

procedure TFMain.ListBox1Click(Sender: TObject);
var
  Text: String;
begin
  ListBox2.Visible := False;
  Text := LocServer.GetItem(ComboBox1.Text, ListBox1.Items.Strings[ListBox1.ItemIndex]);
  if ComboBox1.Text = 'Text' then
    begin
      ListBox2.Visible := True;
      ListBox2.Items.Delimiter := ',';
      ListBox2.Items.QuoteChar := '"';
      ListBox2.Items.DelimitedText := Text;
      ListBox2.ItemIndex := 0;
      ListBox2Click(nil);
    end
  else
    begin
      Edit1.Text := Text;
      Edit1.SetFocus;
      Edit1.SelectAll;
    end;
end;

procedure TFMain.ListBox2Click(Sender: TObject);
begin
  Edit1.Text := ListBox2.Items.Strings[ListBox2.ItemIndex];
  Edit1.SetFocus;
  Edit1.SelectAll;
end;

procedure TFMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFMain.DeleteAllLanguages1Click(Sender: TObject);
var
  i: Integer;
begin
  if MessageDlg('Are You Sure Delete All Languages?.', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      for i := 0 to LocServer.Languages.Count-1 do
        {Delete all with 0. Remember i delete language disapear.}
        LocServer.DeleteLanguage(LocServer.Languages.Strings[0]);
      RefreshClick(nil);
      ClearControls;
    end;
end;

procedure TFMain.ClearControls;
begin
  ComboBox1.Clear;
  ListBox1.Clear;
  ListBox2.Clear;
  Edit1.Clear;
  Label3.Caption := '';
end;

procedure TFMain.Image1DblClick(Sender: TObject);
begin
  if OpenPicture.Execute then
    begin
      Image1.Picture.LoadFromFile(OpenPicture.FileName);
      Post.Enabled := True;
    end;
end;

procedure TFMain.PostClick(Sender: TObject);
var
  s,i: Integer;
begin
  s := ComboBox1.ItemIndex;
  i := ListBox1.ItemIndex;
  if ComboBox1.Text = 'Text' then
    begin
      ListBox2.Items.Strings[ListBox2.ItemIndex] := Edit1.Text;
      LocServer.SetItem(ComboBox1.Text, ListBox1.Items.Strings[ListBox1.ItemIndex], ListBox2.Items.DelimitedText);
    end
  else
    LocServer.SetItem(ComboBox1.Text, ListBox1.Items.Strings[ListBox1.ItemIndex], Edit1.Text);
  LocServer.SetImage(Image1.Picture.BitMap);
  RefreshClick(nil);
  LocServerLanguageChange(nil);
  ComboBox1.ItemIndex := s;
  ComboBox1Change(nil);
  ListBox1.ItemIndex := i;
  ListBox1Click(nil);
  Edit1.SetFocus;
  Edit1.SelectAll;
end;

procedure TFMain.DeleteClick(Sender: TObject);
begin
  if MessageDlg('Are You Sure Delete Language: ' + Label3.Caption + '?.', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      LocServer.DeleteLanguage(Label3.Caption);
      RefreshClick(nil);
      ClearControls;
      if Label3.Caption = '' then
        Delete.Enabled := False;
    end;
end;

procedure TFMain.RefreshClick(Sender: TObject);
begin
  LocServer.RegisterLanguages;
  RefreshLanguageMenu;
end;

procedure TFMain.SpeedButton1Click(Sender: TObject);
begin
  try
    Folders := TFolders.Create(Application);
    if Folders.ShowModal = mrOk then
      begin
        Edit2.Text := Folders.PathList.Path;
        LocServer.DicPath := Edit2.Text;
      end;
  finally
    Folders.Free;
  end;
  RefreshClick(nil);
end;

procedure TFMain.NewSection1Click(Sender: TObject);
begin
  try
    NewKey := TNewKey.Create(Application);
    NewKey.Edit1.Hint := 'New Section Name';
    NewKey.Caption := 'Insert New Section';
    if NewKey.ShowModal = mrOk then
      begin
        LocServer.AddToDictionaries(NewKey.Edit1.Text, '', '');
        ChargeLanguage(Label3.Caption);
        ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(NewKey.Edit1.Text);
      end;
  finally
    NewKey.Free;
  end;
end;

procedure TFMain.NewSubSection1Click(Sender: TObject);
begin
  try
    NewKey := TNewKey.Create(Application);
    NewKey.Edit1.Hint := 'New Item Name';
    NewKey.Caption := 'Insert New Item';
    if NewKey.ShowModal = mrOk then
      begin
        LocServer.AddToDictionaries(ComboBox1.Text, NewKey.Edit1.Text, NewKey.Edit1.Text);
        ChargeLanguage(Label3.Caption);
        ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(ComboBox1.Text);
        ComboBox1Change(nil);
      end;
  finally
    NewKey.Free;
  end;
end;

procedure TFMain.ChargeLanguage(Language: String);
begin
  ComboBox1.Clear;
  if LocServer.GetSections(ComboBox1.Items) then
    begin
      ComboBox1.ItemIndex := 0;
      ComboBox1Change(nil);
    end;
  LocServer.GetActualImage(Image1.Picture.Bitmap);
end;

procedure TFMain.DeleteSection1Click(Sender: TObject);
begin
  if MessageDlg('Are You Sure Delete Section: '+ ComboBox1.Text + '?.', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      LocServer.DeleteDictionarySection(ComboBox1.Text);
      ChargeLanguage(Label3.Caption);
    end;
end;

procedure TFMain.DeleteItem1Click(Sender: TObject);
var
  OldSection: String;
begin
  if MessageDlg('Are You Sure Delete Item: ' + ListBox1.Items.Strings[ListBox1.ItemIndex] + ' from Section: ' + ComboBox1.Text + '?.', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      LocServer.DeleteDictionaryItem(ComboBox1.Text, ListBox1.Items.Strings[ListBox1.ItemIndex]);
      OldSection := ComboBox1.Text;
      ChargeLanguage(Label3.Caption);
      ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(OldSection);
      ComboBox1Change(nil);
    end;
end;

procedure TFMain.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  Post.Enabled := True;
end;

procedure TFMain.LocServerLanguageChange(Sender: TObject);
begin
  Label3.Caption := LocServer.Language;
  if Label3.Caption > '' then
    begin
      Delete.Enabled := True;
      ChargeLanguage(Label3.Caption);
    end;
end;

end.
